#!/usr/bin/perl
#
# send a movie (well, sort of) to the browser.  Works with netscape only,
# other browsers get a static image.  Uses serverpush, i.e. sends the frames
# as multipart/x-mixed-replace elements.
#
# (c) 1999 Gerd Knorr <kraxel@goldbach.in-berlin.de>
#
# 2002, some corrections by V.Shergin (http://www.sao.ru/~vsher)
#        - two channels
#        - fast (>=2Hz) mode on local network
#        - Axis ActivX for MSIE compatibility
use strict;

sub fsleep {
  my $rep = select(undef,undef,undef, shift(@_));
}

# config
my $chan = $ENV{'QUERY_STRING'};
if ($chan =~ /^0/) { $chan = 0; }
if ($chan =~ /^1/) { $chan = 1; }
if ($chan =~ /^2/) { $chan = 2; }
if ($chan != 0 && $chan != 1 && $chan != 2) {
   $chan = 1;
}
my $IMAGE  = "$ENV{'DOCUMENT_ROOT'}/webcam/livecam_$chan.jpeg";
my $MAXSEC = 60;       # 1 min timeout, than need to be reload!

###########################################################################

undef $/;
$|=1;

my $BO = "myboundary-for-livecamera-server-push";

my $serverpush = ( ( $ENV{'HTTP_USER_AGENT'} =~ /^Mozilla/ &&
		     $ENV{'HTTP_USER_AGENT'} !~ /[Cc]ompatible/) ||
		   $ENV{'HTTP_USER_AGENT'} =~ /[Gg]ecko/         ||
		   $ENV{'HTTP_USER_AGENT'} =~ /[Nn]etscape/      ||
		   $ENV{'HTTP_USER_AGENT'} =~ /Opera/ );

my $msie = ( $ENV{'HTTP_USER_AGENT'} =~ /[Mm][Ss][Ii][Ee]/ &&
	     $ENV{'HTTP_USER_AGENT'} !~ /Opera/ );

my $saolocal = ( ( $ENV{'REMOTE_ADDR'} =~ /^192\.168\./ &&
		   $ENV{'REMOTE_ADDR'} !~ /^192\.168\.2\.33/ ) ||
		 $ENV{'HTTP_X_FORWARDED_FOR'} =~ /^192\.168\./ );

my $start = time;
my @st = stat($IMAGE) or die "stat $IMAGE: $!";
my $mtime = $st[9];

if($msie) {           # suppose Axis ActivX for MSIE
 $MAXSEC = 300;       # increase timeout: 5 min
}

###if ($serverpush) {
	print "Content-Type: multipart/x-mixed-replace; boundary=$BO\r\n";
	print "\r\n";
	print "--$BO\r\n";
###}

my $len = 0;
my $nlen = 0;
my $ncadr = 0;
my $nold = 0;

for (my $n=0; ; $n++) {
	# read image
	open IMG, "<$IMAGE";
	my $image = <IMG>;
	close IMG;
	$nlen = length($image);

	if ($len != $nlen && $nlen != 0 && $nlen != 4096) {
		# send it
		$len = $nlen;
		$ncadr++;
		@st = stat($IMAGE);
		$mtime = $st[9];
		$nold=0;

		print  "Content-Type: image/jpeg\r\n";
		printf "Content-Length: %d\r\n",$len;
		print  "\r\n";
		print $image;
#print time - $start;

###             last unless $serverpush;

		if ($saolocal && time - $start < $MAXSEC) {
			print "\r\n\r\n--$BO\r\n";
			fsleep(0.1);
			next;
		}

		# send multipart border
		if (time - $start >= $MAXSEC) {
			print "\r\n\r\n--$BO--\r\n";
			last;
		} else {
			print "\r\n\r\n--$BO\r\n";
		}
	} else {
	       $nold++;
	       fsleep(0.1);
	       if ($nold<10) { next; }
	       if (time - $start >= $MAXSEC) { last; }
	}
	# wait until there is a new image
	while (time - $start < $MAXSEC) {
		@st = stat($IMAGE);
		if ($st[9] != $mtime) {
			$mtime = $st[9];
			fsleep(0.1);
			$len=0;
			$nold=0;
			last;
		}
		if($nold == 0) {
			fsleep(0.1);
		} else {
			fsleep(1.0);
		}
	}
}
exit;
